<h1 align="center">
  <a href="https://joinpeertube.org">
    <img src="https://joinpeertube.org/img/brand.png" alt="PeerTube">
  </a>
</h1>

<p align=center>
  <strong><a href="https://joinpeertube.org">Website</a></strong>
  | <strong><a href="https://joinpeertube.org/instances">Join an instance</a></strong>
  | <strong><a href="https://github.com/Chocobozzz/PeerTube/blob/develop/README.md#package-create-your-own-instance">Create an instance</a></strong>
  | <strong><a href="https://github.com/Chocobozzz/PeerTube/blob/develop/README.md#contact">Chat with us</a></strong>
  | <strong><a href="https://framasoft.org/en/#soutenir">Donate</a></strong>
</p>

<p align="center">
Discover the official PeerTube app, designed to enhance your video-sharing experience. Browse, watch, and interact with content from thousands of PeerTube instances in a user-friendly and seamless way.  
</p>

<p align="center">
  <strong>Developed with &#10084; by <a href="https://framasoft.org">Framasoft</a></strong>
</p>

<p align="center">
  <a href="https://framasoft.org">
    <img width="150px" src="https://lutim.cpy.re/FeRgHH8r.png" alt="Framasoft logo"/>
  </a>
</p>

<a href="https://weblate.framasoft.org/engage/peertube-app/">
<img src="https://weblate.framasoft.org/widget/peertube-app/status-badge.png" alt="Translation status" />
</a>

<br>
<a href="https://apps.apple.com/gb/app/peertube/id6737834858?itscg=30200&itsct=apps_box_badge&mttnsubad=6737834858" target="_blank">
    <img src="https://toolbox.marketingtools.apple.com/api/v2/badges/download-on-the-app-store/black/en-us?releaseDate=1733702400" alt="Download on the App Store" width="246px"/>
</a>
<a href="https://play.google.com/store/apps/details?id=org.framasoft.peertube" target="_blank">
    <img alt="Get it on Google Play" src="https://play.google.com/intl/en_us/badges/static/images/badges/en_badge_web_generic.png" width="290px"/>
</a>

</p>

    

## About the Project

Discover the PeerTube mobile application, a free alternative to video streaming giants like YouTube. Thanks to its decentralised network, PeerTube lets you watch, share and publish videos in complete freedom, while remaining in control of your data.

The official PeerTube application is your gateway to hundreds of thousands of videos, available across more than a thousand different platforms, and now viewable on your mobile device wherever you are.


### Main features of the application
**🎬 Watch videos and subscribe to your favourite channels:** Follow your favourite creators, no matter which instance they're hosted on, and find out what's new on the home screen. Find videos you've watched and saved for later in ‘Library’.

**🌐 Explore the PeerTube federation**: easily browse videos and creators on different PeerTube instances hosted around the world. Discover diverse content from a multitude of interconnected servers. No account required!

**🔎 Search and discover videos**: Use our search engine to find specific videos, channels or themes across the entire PeerTube network. Choose themes that interest you to find the content that's right for you.

### And for future releases
**⬇️ Offline download**: Download videos directly to your device and watch them without an internet connection, wherever and whenever you want.

**🔊 Upload videos from your mobile device**: Easily import your own videos from your device, and contribute to PeerTube's decentralised ecosystem.

**🗨️ Comment and interact**: Comment, discuss and exchange around videos with the PeerTube community.

### Why choose PeerTube?

PeerTube is more than just a video platform. It's a decentralised network that respects your privacy and offers you an ethical alternative to the platforms of surveillance capitalism. Unlike centralised services, PeerTube does not collect your personal data or track you for advertising purposes. With PeerTube, you have complete control over your video experience.

Download the PeerTube application now and join a community that supports a free, decentralised Internet that respects its users.

### Who is behind PeerTube?

PeerTube is a project developed by **Framasoft**, a French non-profit organisation committed to popular education about the digital commons. Framasoft is known for its many initiatives aimed at raising public awareness of alternatives to large centralised platforms and encouraging digital practices that are more respectful of privacy and individual freedoms. This is done in particular through the De-google-ify Internet campaign, which proposes some fifteen services as alternatives to those of the net giants.

You can support Framasoft at [https://soutenir.framasoft.org](https://soutenir.framasoft.org)

## Screenshots

 <center>

<table>
<tr>
<td><a href="./metadata/en-US/images/phoneScreenshots/screenshot1.png"><img width="320" src="./metadata/en-US/images/phoneScreenshots/screenshot1.png"></a></td>
<td><a href="./metadata/en-US/images/phoneScreenshots/screenshot2.png"><img width="320" src="./metadata/en-US/images/phoneScreenshots/screenshot2.png"></a></td>
</tr>
<tr>
<td><a href="./metadata/en-US/images/phoneScreenshots/screenshot3.png"><img width="320" src="./metadata/en-US/images/phoneScreenshots/screenshot3.png"></a></td>
<td><a href="./metadata/en-US/images/phoneScreenshots/screenshot4.png"><img width="320" src="./metadata/en-US/images/phoneScreenshots/screenshot4.png"></a></td>
</tr>
</table>

</center>

## License

This project is licensed under the GNU General Public License v3.0. You may copy, distribute, and modify the software as long as you track changes/dates in source files. Any derivative works must also be licensed under the GPL v3. For more details, refer to the [GPL v3 License](https://www.gnu.org/licenses/gpl-3.0.en.html).
