import 'package:json_annotation/json_annotation.dart';

import 'package:peertube_mobile/shared/actor/actor_image_model.dart';
import 'package:peertube_mobile/shared/actor/actor_model.dart';

part 'account_model.g.dart';

@JsonSerializable()
class Account implements Actor {
  @override
  final int id;
  @override
  final String url;
  @override
  final String name;
  @override
  final String host;
  @override
  final String displayName;
  @override
  final List<ActorImage> avatars;

  Account({
    required this.id,
    required this.url,
    required this.name,
    required this.host,
    required this.displayName,
    required this.avatars,
  });

  factory Account.fromJson(Map<String, dynamic> json) =>
      _$AccountFromJson(json);
  Map<String, dynamic> toJson() => _$AccountToJson(this);
}

@JsonSerializable()
class AccountDetails implements Actor {
  @override
  final int id;
  @override
  final String url;
  @override
  final String name;
  @override
  final String host;
  final bool? hostRedundancyAllowed;
  final int followingCount;
  final int followersCount;
  final DateTime createdAt;
  @override
  final String displayName;
  final DateTime updatedAt;
  @override
  final List<ActorImage> avatars;
  final String? description;
  final int? userId;

  AccountDetails({
    required this.id,
    required this.url,
    required this.name,
    required this.host,
    this.hostRedundancyAllowed,
    required this.followingCount,
    required this.followersCount,
    required this.createdAt,
    required this.displayName,
    required this.updatedAt,
    required this.avatars,
    this.description,
    this.userId,
  });

  factory AccountDetails.fromJson(Map<String, dynamic> json) =>
      _$AccountDetailsFromJson(json);
  Map<String, dynamic> toJson() => _$AccountDetailsToJson(this);
}
