import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/account/account_datasource.dart';
import 'package:peertube_mobile/features/account/account_model.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final accountDatasourceProvider = Provider.autoDispose<AccountDatasource>(
  (ref) => AccountDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    httpService: ref.watch(httpServiceProvider),
  ),
  name: 'accountDatasourceProvider',
);

final totalVideoChannelsProvider =
    FutureProvider.autoDispose.family<int, String>(
  (ref, name) async =>
      ref.read(accountDatasourceProvider).getTotalVideoChannels(
            name,
          ),
);

final accountDetailsProvider =
    FutureProvider.autoDispose.family<AccountDetails, String>(
  (ref, name) async => ref.read(accountDatasourceProvider).fetchAccount(name),
);
