class ConnectedAccountSQL {
  final int id;
  final String username;
  final String host;
  final String displayName;
  final String? avatarUrl;
  final bool isFavorite;
  final DateTime lastAccess;

  ConnectedAccountSQL({
    required this.id,
    required this.username,
    required this.host,
    required this.displayName,
    this.avatarUrl,
    required this.isFavorite,
    required this.lastAccess,
  });

  bool isLocal() => host == 'localhost';

  factory ConnectedAccountSQL.fromMap(Map<String, dynamic> map) {
    return ConnectedAccountSQL(
      id: map['id'] as int,
      username: map['username'] as String,
      host: map['host'] as String,
      displayName: map['displayName'] as String,
      avatarUrl: map['avatarUrl'] as String?,
      isFavorite: map['isFavorite'] == 1,
      lastAccess: DateTime.fromMillisecondsSinceEpoch(map['lastAccess'] as int),
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'username': username,
      'host': host,
      'displayName': displayName,
      'avatarUrl': avatarUrl,
      'isFavorite': isFavorite ? 1 : 0,
      'lastAccess': lastAccess.millisecondsSinceEpoch,
    };
  }
}
