import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/account/connected_account/connected_account_model.dart';
import 'package:peertube_mobile/features/account/connected_account/connected_account_service.dart';
import 'package:peertube_mobile/features/account/connected_account/current_connected_account_notifier.dart';
import 'package:peertube_mobile/shared/database/database.dart';
import 'package:peertube_mobile/shared/preferences/user_preferences.dart';

final currentConnectedAccountProvider =
    AsyncNotifierProvider<CurrentConnectedAccountNotifier, ConnectedAccountSQL>(
  CurrentConnectedAccountNotifier.new,
  name: 'currentConnectedAccountProvider',
);

final connectedAccountServiceProvider = Provider<ConnectedAccountService>(
  (ref) => ConnectedAccountService(
    sharedUtility: ref.watch(sharedUtilityProvider),
    database: ref.watch(databaseProvider),
  ),
  name: 'connectedAccountServiceProvider',
);
