import 'dart:async';

import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/account/connected_account/connected_account_model.dart';
import 'package:peertube_mobile/features/account/connected_account/connected_account_providers.dart';

class CurrentConnectedAccountNotifier
    extends AsyncNotifier<ConnectedAccountSQL> {
  @override
  Future<ConnectedAccountSQL> build() async {
    final accountService = ref.read(connectedAccountServiceProvider);
    final favoriteAccount = await accountService.getFavoriteAccount();
    if (favoriteAccount != null) {
      return favoriteAccount;
    }
    return await accountService.getLocalAccount();
  }

  // Future<void> loadCurrentAccount(String userWithHost) async {
  //   state = const AsyncValue.loading();
  //   state = await AsyncValue.guard(
  //     () async => ref
  //         .read(accountServiceProvider)
  //         .getAccountByUserWithHost(userWithHost),
  //   );
  // }
}
