class LocalWatchLaterPlaylistElementSQL {
  final int? id;
  final String videoUuid;
  final String domain;
  final String name;
  final String? previewPath;
  final int duration;
  final String channelDisplayName;
  final int positionInPlaylist;

  LocalWatchLaterPlaylistElementSQL({
    this.id,
    required this.videoUuid,
    required this.domain,
    required this.name,
    this.previewPath,
    required this.duration,
    required this.channelDisplayName,
    required this.positionInPlaylist,
  });

  factory LocalWatchLaterPlaylistElementSQL.fromMap(Map<String, dynamic> map) {
    return LocalWatchLaterPlaylistElementSQL(
      id: map['id'] as int?,
      videoUuid: map['videoUuid'] as String,
      domain: map['domain'] as String,
      name: map['name'] as String,
      previewPath: map['previewPath'] as String?,
      duration: map['duration'] as int,
      channelDisplayName: map['channelDisplayName'] as String,
      positionInPlaylist: map['positionInPlaylist'] as int,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'videoUuid': videoUuid,
      'domain': domain,
      'name': name,
      'previewPath': previewPath,
      'duration': duration,
      'channelDisplayName': channelDisplayName,
      'positionInPlaylist': positionInPlaylist,
    };
  }
}

class LocalHistoryElementSQL {
  final int? id;
  final String videoUuid;
  final String domain;
  final String name;
  final String? previewPath;
  final int duration;
  final String channelDisplayName;
  final int currentPosition;
  final DateTime watchedAt;

  LocalHistoryElementSQL({
    this.id,
    required this.videoUuid,
    required this.domain,
    required this.name,
    this.previewPath,
    required this.duration,
    required this.channelDisplayName,
    required this.currentPosition,
    required this.watchedAt,
  });

  factory LocalHistoryElementSQL.fromMap(Map<String, dynamic> map) {
    return LocalHistoryElementSQL(
      id: map['id'] as int?,
      videoUuid: map['videoUuid'] as String,
      domain: map['domain'] as String,
      name: map['name'] as String,
      previewPath: map['previewPath'] as String?,
      duration: map['duration'] as int,
      channelDisplayName: map['channelDisplayName'] as String,
      currentPosition: map['currentPosition'] as int,
      watchedAt: DateTime.fromMillisecondsSinceEpoch(map['watchedAt'] as int),
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'videoUuid': videoUuid,
      'domain': domain,
      'name': name,
      'previewPath': previewPath,
      'duration': duration,
      'channelDisplayName': channelDisplayName,
      'currentPosition': currentPosition,
      'watchedAt': watchedAt.millisecondsSinceEpoch,
    };
  }
}
