import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/account/connected_account/local_account/local_account_model.dart';
import 'package:peertube_mobile/features/account/connected_account/local_account/local_account_service.dart';
import 'package:peertube_mobile/features/account/connected_account/local_account/local_history_notifier.dart';
import 'package:peertube_mobile/features/account/connected_account/local_account/local_watch_later_notifier.dart';
import 'package:peertube_mobile/shared/database/database.dart';

final localAccountServiceProvider = Provider<LocalAccountService>(
  (ref) => LocalAccountService(
    database: ref.watch(databaseProvider),
  ),
  name: 'localAccountServiceProvider',
);

final localWatchLaterPlaylistProvider = AsyncNotifierProvider<
    AsyncWatchLaterListNotifier, List<LocalWatchLaterPlaylistElementSQL>>(
  AsyncWatchLaterListNotifier.new,
  name: 'localWatchLaterPlaylistProvider',
);

final localHistoryProvider = AsyncNotifierProvider<AsyncLocalHistoryNotifier,
    List<LocalHistoryElementSQL>>(
  AsyncLocalHistoryNotifier.new,
  name: 'localHistoryProvider',
);
