import 'package:flutter/material.dart';

import 'package:lucide_icons/lucide_icons.dart';

import 'package:peertube_mobile/shared/widgets/image.dart';

class LocalVideoListTile extends StatelessWidget {
  final String imageUrl;
  final String title;
  final String subtitle;
  final bool isEditing;
  final VoidCallback? onDelete;
  final VoidCallback? onTap;

  const LocalVideoListTile({
    super.key,
    required this.imageUrl,
    required this.title,
    required this.subtitle,
    this.isEditing = false,
    this.onDelete,
    this.onTap,
  });

  @override
  Widget build(BuildContext context) {
    return ListTile(
      leading: CustomCachedNetworkImage(
        imageUrl: imageUrl,
        width: 100,
      ),
      title: Text(title),
      subtitle: Text(subtitle),
      trailing: isEditing && onDelete != null
          ? IconButton(
              icon: const Icon(LucideIcons.trash2),
              onPressed: onDelete,
            )
          : null,
      onTap: onTap,
    );
  }
}
