import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/shared/filters/filters_providers.dart';

final showAllContentFiltersProvider =
    StateProvider.autoDispose<bool>((_) => false);

final filterByMyInterestsSwitchProvider = StateProvider<bool>(
  (ref) {
    ref.listenSelf((bool? prev, bool curr) {
      if (prev != curr && prev != null) {
        final notifier = ref.read(exploreSearchVideoFilterProvider.notifier);
        curr ? notifier.applyInterests() : notifier.reset();
      }
    });

    return false;
  },
  name: 'filterByMyInterestsSwitchProvider',
);
