import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/moderation/abuse_datasource.dart';
import 'package:peertube_mobile/features/moderation/abuse_service.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final abuseDatasourceProvider = Provider.autoDispose<AbuseDatasource>(
  (ref) => AbuseDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    httpService: ref.watch(httpServiceProvider),
  ),
  name: 'abuseDatasourceProvider',
);

final abuseServiceProvider = Provider.autoDispose<AbuseService>(
  (ref) => AbuseService(
    abuseDatasource: ref.watch(abuseDatasourceProvider),
  ),
  name: 'abuseServiceProvider',
);
