import 'package:peertube_mobile/features/moderation/abuse_datasource.dart';
import 'package:peertube_mobile/features/moderation/predefined_reasons_enum.dart';

class AbuseService {
  final AbuseDatasource abuseDatasource;

  AbuseService({required this.abuseDatasource});

  Future<int> reportVideo({
    required String reason,
    required int videoId,
    int? videoStartAt,
    int? videoEndAt,
    List<PredefinedReasons>? predefinedReasons,
  }) {
    return abuseDatasource.reportAbuse(
      reason: reason,
      videoId: videoId,
      videoStartAt: videoStartAt,
      videoEndAt: videoEndAt,
      predefinedReasons: predefinedReasons,
    );
  }

  Future<int> reportAccount({
    required String reason,
    required int accountId,
    List<PredefinedReasons>? predefinedReasons,
  }) {
    return abuseDatasource.reportAbuse(
      reason: reason,
      accountId: accountId,
      predefinedReasons: predefinedReasons,
    );
  }

  Future<int> reportComment({
    required String reason,
    required int commentId,
    List<PredefinedReasons>? predefinedReasons,
  }) {
    return abuseDatasource.reportAbuse(
      reason: reason,
      commentId: commentId,
      predefinedReasons: predefinedReasons,
    );
  }
}
