class PlatformHistoryElementSQL {
  final int? id;
  final String domain;
  final String name;
  final String? avatarUrl;
  final bool bookmarked;
  final DateTime lastAccess;
  final int accountId;

  PlatformHistoryElementSQL({
    this.id,
    required this.domain,
    required this.name,
    this.avatarUrl,
    required this.bookmarked,
    required this.lastAccess,
    required this.accountId,
  });

  factory PlatformHistoryElementSQL.fromMap(Map<String, dynamic> map) {
    return PlatformHistoryElementSQL(
      id: map['id'] as int?,
      domain: map['domain'] as String,
      name: map['name'] as String,
      avatarUrl: map['avatarUrl'] as String?,
      bookmarked: map['bookmarked'] == 1,
      lastAccess: DateTime.fromMillisecondsSinceEpoch(map['lastAccess'] as int),
      accountId: map['accountId'] as int,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'id': id,
      'domain': domain,
      'name': name,
      'avatarUrl': avatarUrl,
      'bookmarked': bookmarked ? 1 : 0,
      'lastAccess': lastAccess.millisecondsSinceEpoch,
      'accountId': accountId,
    };
  }
}
