import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/platform/history/platform_history_model.dart';
import 'package:peertube_mobile/features/platform/history/platform_history_notifier.dart';
import 'package:peertube_mobile/features/platform/history/platform_history_service.dart';
import 'package:peertube_mobile/shared/database/database.dart';
import 'package:peertube_mobile/shared/preferences/user_preferences.dart';

final platformHistoryProvider = AsyncNotifierProvider<
    AsyncPlatformHistoryNotifier, List<PlatformHistoryElementSQL>>(
  AsyncPlatformHistoryNotifier.new,
  name: 'platformHistoryProvider',
);

final platformHistoryServiceProvider = Provider<PlatformHistoryService>(
  (ref) => PlatformHistoryService(
    sharedUtility: ref.watch(sharedUtilityProvider),
    database: ref.watch(databaseProvider),
  ),
  name: 'platformHistoryServiceProvider',
);
