import 'dart:io';

import 'package:dio/dio.dart';

import 'package:peertube_mobile/features/platform/joinpeertube/joinpeertube_models.dart';
import 'package:peertube_mobile/shared/filters/platform/platform_params_model.dart';

class JoinpeertubeDatasource {
  final Dio httpClient;
  JoinpeertubeDatasource({
    required this.httpClient,
  });

  Future<List<PlatformJPT>> listPlatforms(PlatformParams queryParams) async {
    try {
      final response = await httpClient.get(
        'https://instances.joinpeertube.org/api/v1/instances',
        queryParameters: queryParams.toJson(),
      );

      if (response.statusCode == HttpStatus.ok) {
        List<dynamic> platformList = response.data['data'];
        return platformList
            .map((platform) => PlatformJPT.fromJson(platform))
            .toList();
      } else {
        throw Exception(response.data['error']);
      }
    } catch (e) {
      throw Exception('An error has occurred: $e');
    }
  }
}
