import 'package:json_annotation/json_annotation.dart';

part 'joinpeertube_models.g.dart';

@JsonSerializable()
class PlatformImage {
  final int width;
  final String url;

  PlatformImage({
    required this.width,
    required this.url,
  });

  factory PlatformImage.fromJson(Map<String, dynamic> json) =>
      _$PlatformImageFromJson(json);

  Map<String, dynamic> toJson() => _$PlatformImageToJson(this);
}

@JsonSerializable(explicitToJson: true)
class PlatformJPT {
  final int id;
  final String host;
  final String name;
  String? shortDescription;
  final String version;
  final List<int> categories;
  final String? defaultNSFWPolicy;
  final bool? isNSFW;
  final List<PlatformImage> avatars;
  final List<PlatformImage> banners;
  final int totalUsers;
  final int totalVideos;
  final int totalLocalVideos;
  final int totalInstanceFollowers;
  final int totalInstanceFollowing;
  // final int totalModerators;
  // final int totalAdmins;
  // final int totalAbusesProcessed;
  // final int totalAbuses;
  String? country;
  final int health;
  final DateTime createdAt;

  PlatformJPT({
    required this.id,
    required this.host,
    required this.name,
    this.shortDescription,
    required this.version,
    required this.categories,
    this.defaultNSFWPolicy,
    required this.isNSFW,
    required this.avatars,
    required this.banners,
    required this.totalUsers,
    required this.totalVideos,
    required this.totalLocalVideos,
    required this.totalInstanceFollowers,
    required this.totalInstanceFollowing,
    // required this.totalModerators,
    // required this.totalAdmins,
    // required this.totalAbusesProcessed,
    // required this.totalAbuses,
    this.country,
    required this.health,
    required this.createdAt,
  });

  factory PlatformJPT.fromJson(Map<String, dynamic> json) =>
      _$PlatformJPTFromJson(json);

  Map<String, dynamic> toJson() => _$PlatformJPTToJson(this);
}
