import 'package:json_annotation/json_annotation.dart';

part 'captions_model.g.dart';

@JsonSerializable()
class CaptionsLanguage {
  final String id;
  final String label;

  CaptionsLanguage({required this.id, required this.label});

  factory CaptionsLanguage.fromJson(Map<String, dynamic> json) =>
      _$CaptionsLanguageFromJson(json);
  Map<String, dynamic> toJson() => _$CaptionsLanguageToJson(this);
}

@JsonSerializable()
class Captions {
  final CaptionsLanguage language;

  final bool? automaticallyGenerated;
  final String captionPath;
  final DateTime updatedAt;

  Captions({
    required this.language,
    this.automaticallyGenerated,
    required this.captionPath,
    required this.updatedAt,
  });

  factory Captions.fromJson(Map<String, dynamic> json) =>
      _$CaptionsFromJson(json);
  Map<String, dynamic> toJson() => _$CaptionsToJson(this);
}
