import 'dart:io';

import 'package:peertube_mobile/features/video/channel/channel_model.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_models.dart';
import 'package:peertube_mobile/shared/network/http_service.dart';

class VideoChannelDatasource {
  final CurrentPlatform currentPlatform;
  final HttpService httpService;

  VideoChannelDatasource({
    required this.currentPlatform,
    required this.httpService,
  });

  Future<VideoChannelDetails> fetchVideoChannel(String channelHandle) async {
    final response = await httpService.get(
      path: currentPlatform.getApiBaseUrl('/video-channels/$channelHandle'),
      expectedStatusCode: HttpStatus.ok,
    );

    try {
      return VideoChannelDetails.fromJson(response.data);
    } catch (e) {
      throw Exception('Error parsing video channel: $e');
    }
  }
}
