import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/video/channel/channel_datasource.dart';
import 'package:peertube_mobile/features/video/channel/channel_model.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final videoChannelDatasourceProvider =
    Provider.autoDispose<VideoChannelDatasource>(
  (ref) => VideoChannelDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    httpService: ref.watch(httpServiceProvider),
  ),
  name: 'videoChannelDatasourceProvider',
);

final videoChannelDetailsProvider =
    FutureProvider.autoDispose.family<VideoChannelDetails, String>(
  (ref, channelHandle) async =>
      ref.read(videoChannelDatasourceProvider).fetchVideoChannel(channelHandle),
);
