import 'package:json_annotation/json_annotation.dart';

import 'package:peertube_mobile/features/account/account_model.dart';

part 'comment_model.g.dart';

@JsonSerializable()
class VideoCommentThread {
  final int id;
  final String url;
  final String text;
  final int threadId;
  final int? inReplyToCommentId;
  final int videoId;
  final DateTime createdAt;
  final DateTime updatedAt;
  final DateTime? deletedAt;
  final bool isDeleted;
  final Account? account;
  final int totalRepliesFromVideoAuthor;
  final int totalReplies;
  final String? by;
  final bool? isLocal;

  VideoCommentThread({
    required this.id,
    required this.url,
    required this.text,
    required this.threadId,
    this.inReplyToCommentId,
    required this.videoId,
    required this.createdAt,
    required this.updatedAt,
    this.deletedAt,
    required this.isDeleted,
    this.account,
    required this.totalRepliesFromVideoAuthor,
    required this.totalReplies,
    this.by,
    this.isLocal,
  });

  factory VideoCommentThread.fromJson(Map<String, dynamic> json) =>
      _$VideoCommentThreadFromJson(json);
  Map<String, dynamic> toJson() => _$VideoCommentThreadToJson(this);
}

@JsonSerializable()
class VideoCommentThreadTree {
  final VideoCommentThread comment;
  final List<VideoCommentThreadTree> children;

  VideoCommentThreadTree({
    required this.comment,
    required this.children,
  });

  factory VideoCommentThreadTree.fromJson(Map<String, dynamic> json) =>
      _$VideoCommentThreadTreeFromJson(json);
  Map<String, dynamic> toJson() => _$VideoCommentThreadTreeToJson(this);
}
