import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/video/comments/comment_datasource.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final videoCommentDatasourceProvider = Provider<VideoCommentDatasource>(
  (ref) => VideoCommentDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    httpService: ref.watch(httpServiceProvider),
  ),
  name: 'videoCommentDatasourceProvider',
);

final totalCommentsProvider = FutureProvider.autoDispose.family<int, String>(
  (ref, videoUuid) async =>
      ref.read(videoCommentDatasourceProvider).getTotalNotDeletedComments(
            videoUuid,
          ),
);
