import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/video/history/history_datasource.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final historyDatasourceProvider = Provider.autoDispose<HistoryDatasource>(
  (ref) => HistoryDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    httpService: ref.watch(httpServiceProvider),
  ),
  name: 'historyDatasourceProvider',
);
