import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/video/playlist/playlist_datasource.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final playlistDatasourceProvider = Provider.autoDispose<PlaylistDatasource>(
  (ref) => PlaylistDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    httpService: ref.watch(httpServiceProvider),
  ),
  name: 'playlistDatasourceProvider',
);
