import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/video/rating/rating_datasource.dart';
import 'package:peertube_mobile/features/video/rating/rating_service.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final ratingDatasourceProvider = Provider<RatingDatasource>(
  (ref) => RatingDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    peertubeClient: ref.watch(httpClientProvider),
  ),
  name: 'ratingDatasourceProvider',
);

final ratingServiceProvider = Provider<RatingService>(
  (ref) => RatingService(
    rating: ref.watch(ratingDatasourceProvider),
  ),
  name: 'ratingServiceProvider',
);
