import 'package:peertube_mobile/features/video/rating/rating_datasource.dart';

class RatingService {
  final RatingDatasource rating;

  RatingService({required this.rating});

  Future<String> getRate(int videoId) async => rating.getRate(videoId);

  Future<List<int>> updateRate({
    required int videoId,
    required String lastRating,
    required String newRating,
    required int likeCount,
    required int dislikeCount,
  }) async {
    try {
      rating.rateVideo(videoId, newRating);
      if (lastRating == 'like') {
        likeCount--;
      } else if (lastRating == 'dislike') {
        dislikeCount--;
      }
      if (newRating == 'like' && lastRating != 'like') {
        likeCount++;
      } else if (newRating == 'dislike' && lastRating != 'dislike') {
        dislikeCount++;
      }

      lastRating = (lastRating == newRating) ? 'none' : newRating;

      return [likeCount, dislikeCount];
    } catch (e) {
      throw Exception('An error has occurred : $e');
    }
  }
}
