import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/video/search/search_datasource.dart';
import 'package:peertube_mobile/features/video/search/search_service.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final searchDatasourceProvider = Provider.autoDispose<SearchDatasource>(
  (ref) => SearchDatasource(
    httpClient: ref.watch(httpClientProvider),
  ),
  name: 'searchDatasourceProvider',
);

final searchServiceProvider = Provider.autoDispose<SearchService>(
  (ref) => SearchService(
    searchDatasource: ref.watch(searchDatasourceProvider),
  ),
  name: 'searchServiceProvider',
);
