import 'dart:async';

import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/features/video/video_model.dart';
import 'package:peertube_mobile/features/video/video_providers.dart';

class SelectedVideoNotifier extends Notifier<VideoDetails?> {
  @override
  VideoDetails? build() {
    return null;
  }

  Future<VideoDetails?> loadSelectedVideo(String videoUUID) async {
    try {
      final videoDetails =
          await ref.read(videoDatasourceProvider).fetchVideo(videoUUID);
      state = videoDetails;
      return videoDetails;
    } catch (error) {
      // Handle the error
      return null;
    }
  }
}
