import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/shared/auth/auth_datasource.dart';
import 'package:peertube_mobile/shared/auth/auth_service.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_providers.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';
import 'package:peertube_mobile/shared/storage/storage_providers.dart';

final authDatasourceProvider = Provider<AuthDatasource>(
  (ref) => AuthDatasource(
    currentPlatform: ref.watch(currentPlatformNonNullableProvider),
    httpClient: ref.watch(httpClientProvider),
  ),
  name: 'authDatasourceProvider',
);

final authServiceProvider = Provider<AuthService>(
  (ref) => AuthService(
    auth: ref.watch(authDatasourceProvider),
    storage: ref.watch(secureStorageServiceProvider),
  ),
  name: 'authServiceProvider',
);
