import 'package:flutter/foundation.dart';
import 'package:flutter/widgets.dart';

import 'package:peertube_mobile/shared/auth/token_api_model.dart';

@immutable
class Token extends TokenAPI {
  final String clientId;
  final String clientSecret;

  const Token({
    required this.clientId,
    required this.clientSecret,
    required super.accessToken,
    required super.refreshToken,
    required super.tokenType,
  });

  factory Token.fromJson(Map<String, dynamic> json) {
    return Token(
      clientId: json['client_id'],
      clientSecret: json['client_secret'],
      accessToken: json['access_token'] as String,
      refreshToken: json['refresh_token'] as String,
      tokenType: json['token_type'] as String,
    );
  }

  Map<String, dynamic> toJson() {
    return <String, dynamic>{
      'client_id': clientId,
      'client_secret': clientSecret,
      'access_token': accessToken,
      'refresh_token': refreshToken,
      'token_type': tokenType,
    };
  }

  Token copyWith() => Token(
        clientId: clientId,
        clientSecret: clientSecret,
        accessToken: accessToken,
        refreshToken: refreshToken,
        tokenType: tokenType,
      );
}
