import 'package:json_annotation/json_annotation.dart';

import 'package:peertube_mobile/shared/actor/actor_image_model.dart';

part 'config_models.g.dart';

@JsonSerializable()
class ConfigServer {
  final String serverVersion;
  // final String? serverCommit;
  // final ConfigClient client;
  final ConfigInstance instance;
  // final ConfigSearch search;
  // final ConfigEmail email;
  // final ConfigContactForm contactForm;
  // final ConfigSignup signup;
  // final ConfigAutoBlacklist autoBlacklist;
  // final ConfigAvatar avatar;
  // final ConfigBanner banner;
  // final ConfigTrending trending;
  // final ConfigTracker tracker;
  // final ConfigBroadcastMessage broadcastMessage;
  // final ConfigViews views;
  // final ConfigStoryboards? storyboards;

  ConfigServer({
    required this.serverVersion,
    // this.serverCommit,
    // required this.client,
    required this.instance,
    // required this.search,
    // required this.email,
    // required this.contactForm,
    // required this.signup,
    // required this.autoBlacklist,
    // required this.avatar,
    // required this.banner,
    // required this.trending,
    // required this.tracker,
    // required this.broadcastMessage,
    // required this.views,
    // this.storyboards,
  });

  factory ConfigServer.fromJson(Map<String, dynamic> json) =>
      _$ConfigServerFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigServerToJson(this);
}

@JsonSerializable()
class ConfigClient {
  final ConfigVideos videos;
  final ConfigMenu menu;

  ConfigClient({
    required this.videos,
    required this.menu,
  });

  factory ConfigClient.fromJson(Map<String, dynamic> json) =>
      _$ConfigClientFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigClientToJson(this);
}

@JsonSerializable()
class ConfigVideos {
  final ConfigMiniature miniature;
  final ConfigResumableUpload resumableUpload;

  ConfigVideos({
    required this.miniature,
    required this.resumableUpload,
  });

  factory ConfigVideos.fromJson(Map<String, dynamic> json) =>
      _$ConfigVideosFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigVideosToJson(this);
}

@JsonSerializable()
class ConfigMiniature {
  final bool displayAuthorAvatar;
  final bool preferAuthorDisplayName;

  ConfigMiniature({
    required this.displayAuthorAvatar,
    required this.preferAuthorDisplayName,
  });

  factory ConfigMiniature.fromJson(Map<String, dynamic> json) =>
      _$ConfigMiniatureFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigMiniatureToJson(this);
}

@JsonSerializable()
class ConfigResumableUpload {
  final int maxChunkSize;

  ConfigResumableUpload({
    required this.maxChunkSize,
  });

  factory ConfigResumableUpload.fromJson(Map<String, dynamic> json) =>
      _$ConfigResumableUploadFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigResumableUploadToJson(this);
}

@JsonSerializable()
class ConfigMenu {
  final ConfigLogin login;

  ConfigMenu({
    required this.login,
  });

  factory ConfigMenu.fromJson(Map<String, dynamic> json) =>
      _$ConfigMenuFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigMenuToJson(this);
}

@JsonSerializable()
class ConfigLogin {
  final bool redirectOnSingleExternalAuth;

  ConfigLogin({
    required this.redirectOnSingleExternalAuth,
  });

  factory ConfigLogin.fromJson(Map<String, dynamic> json) =>
      _$ConfigLoginFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigLoginToJson(this);
}

@JsonSerializable()
class ConfigInstance {
  final String name;
  final String shortDescription;
  final bool isNSFW;
  final String defaultNSFWPolicy;
  final String defaultClientRoute;
  final List<ActorImage>? avatars;
  final List<ActorImage>? banners;

  ConfigInstance({
    required this.name,
    required this.shortDescription,
    required this.isNSFW,
    required this.defaultNSFWPolicy,
    required this.defaultClientRoute,
    this.avatars,
    this.banners,
  });

  factory ConfigInstance.fromJson(Map<String, dynamic> json) =>
      _$ConfigInstanceFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigInstanceToJson(this);
}

@JsonSerializable()
class ConfigSearch {
  final ConfigRemoteUri remoteUri;
  final ConfigSearchIndex searchIndex;

  ConfigSearch({
    required this.remoteUri,
    required this.searchIndex,
  });

  factory ConfigSearch.fromJson(Map<String, dynamic> json) =>
      _$ConfigSearchFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigSearchToJson(this);
}

@JsonSerializable()
class ConfigRemoteUri {
  final bool users;
  final bool anonymous;

  ConfigRemoteUri({
    required this.users,
    required this.anonymous,
  });

  factory ConfigRemoteUri.fromJson(Map<String, dynamic> json) =>
      _$ConfigRemoteUriFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigRemoteUriToJson(this);
}

@JsonSerializable()
class ConfigSearchIndex {
  final bool enabled;
  final String url;
  final bool disableLocalSearch;
  final bool isDefaultSearch;

  ConfigSearchIndex({
    required this.enabled,
    required this.url,
    required this.disableLocalSearch,
    required this.isDefaultSearch,
  });

  factory ConfigSearchIndex.fromJson(Map<String, dynamic> json) =>
      _$ConfigSearchIndexFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigSearchIndexToJson(this);
}

@JsonSerializable()
class ConfigEmail {
  final bool enabled;

  ConfigEmail({
    required this.enabled,
  });

  factory ConfigEmail.fromJson(Map<String, dynamic> json) =>
      _$ConfigEmailFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigEmailToJson(this);
}

@JsonSerializable()
class ConfigContactForm {
  final bool enabled;

  ConfigContactForm({
    required this.enabled,
  });

  factory ConfigContactForm.fromJson(Map<String, dynamic> json) =>
      _$ConfigContactFormFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigContactFormToJson(this);
}

@JsonSerializable()
class ConfigSignup {
  final bool allowed;
  final bool allowedForCurrentIP;
  final bool requiresEmailVerification;
  final bool? requiresApproval;
  final int minimumAge;

  ConfigSignup({
    required this.allowed,
    required this.allowedForCurrentIP,
    required this.requiresEmailVerification,
    this.requiresApproval,
    required this.minimumAge,
  });

  factory ConfigSignup.fromJson(Map<String, dynamic> json) =>
      _$ConfigSignupFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigSignupToJson(this);
}

@JsonSerializable()
class ConfigAutoBlacklist {
  final ConfigVideosBlacklist videos;

  ConfigAutoBlacklist({
    required this.videos,
  });

  factory ConfigAutoBlacklist.fromJson(Map<String, dynamic> json) =>
      _$ConfigAutoBlacklistFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigAutoBlacklistToJson(this);
}

@JsonSerializable()
class ConfigVideosBlacklist {
  final ConfigOfUsers ofUsers;

  ConfigVideosBlacklist({
    required this.ofUsers,
  });

  factory ConfigVideosBlacklist.fromJson(Map<String, dynamic> json) =>
      _$ConfigVideosBlacklistFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigVideosBlacklistToJson(this);
}

@JsonSerializable()
class ConfigOfUsers {
  final bool enabled;

  ConfigOfUsers({
    required this.enabled,
  });

  factory ConfigOfUsers.fromJson(Map<String, dynamic> json) =>
      _$ConfigOfUsersFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigOfUsersToJson(this);
}

@JsonSerializable()
class ConfigAvatar {
  final ConfigFile file;

  ConfigAvatar({
    required this.file,
  });

  factory ConfigAvatar.fromJson(Map<String, dynamic> json) =>
      _$ConfigAvatarFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigAvatarToJson(this);
}

@JsonSerializable()
class ConfigFile {
  final ConfigFileSize size;
  final List<String> extensions;

  ConfigFile({
    required this.size,
    required this.extensions,
  });

  factory ConfigFile.fromJson(Map<String, dynamic> json) =>
      _$ConfigFileFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigFileToJson(this);
}

@JsonSerializable()
class ConfigFileSize {
  final int max;

  ConfigFileSize({
    required this.max,
  });

  factory ConfigFileSize.fromJson(Map<String, dynamic> json) =>
      _$ConfigFileSizeFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigFileSizeToJson(this);
}

@JsonSerializable()
class ConfigBanner {
  final ConfigFile file;

  ConfigBanner({
    required this.file,
  });

  factory ConfigBanner.fromJson(Map<String, dynamic> json) =>
      _$ConfigBannerFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigBannerToJson(this);
}

@JsonSerializable()
class ConfigTrending {
  final ConfigTrendingVideos videos;

  ConfigTrending({
    required this.videos,
  });

  factory ConfigTrending.fromJson(Map<String, dynamic> json) =>
      _$ConfigTrendingFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigTrendingToJson(this);
}

@JsonSerializable()
class ConfigTrendingVideos {
  final int intervalDays;
  final ConfigAlgorithms algorithms;

  ConfigTrendingVideos({
    required this.intervalDays,
    required this.algorithms,
  });

  factory ConfigTrendingVideos.fromJson(Map<String, dynamic> json) =>
      _$ConfigTrendingVideosFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigTrendingVideosToJson(this);
}

@JsonSerializable()
class ConfigAlgorithms {
  final List<String> enabled;
  final String defaultAlgorithm;

  ConfigAlgorithms({
    required this.enabled,
    required this.defaultAlgorithm,
  });

  factory ConfigAlgorithms.fromJson(Map<String, dynamic> json) =>
      _$ConfigAlgorithmsFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigAlgorithmsToJson(this);
}

@JsonSerializable()
class ConfigTracker {
  final bool enabled;

  ConfigTracker({
    required this.enabled,
  });

  factory ConfigTracker.fromJson(Map<String, dynamic> json) =>
      _$ConfigTrackerFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigTrackerToJson(this);
}

@JsonSerializable()
class ConfigBroadcastMessage {
  final bool enabled;
  final String message;
  final String level;
  final bool dismissable;

  ConfigBroadcastMessage({
    required this.enabled,
    required this.message,
    required this.level,
    required this.dismissable,
  });

  factory ConfigBroadcastMessage.fromJson(Map<String, dynamic> json) =>
      _$ConfigBroadcastMessageFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigBroadcastMessageToJson(this);
}

@JsonSerializable()
class ConfigViews {
  final ConfigVideoViews videos;

  ConfigViews({
    required this.videos,
  });

  factory ConfigViews.fromJson(Map<String, dynamic> json) =>
      _$ConfigViewsFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigViewsToJson(this);
}

@JsonSerializable()
class ConfigVideoViews {
  final ConfigWatchingInterval watchingInterval;

  ConfigVideoViews({
    required this.watchingInterval,
  });

  factory ConfigVideoViews.fromJson(Map<String, dynamic> json) =>
      _$ConfigVideoViewsFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigVideoViewsToJson(this);
}

@JsonSerializable()
class ConfigWatchingInterval {
  final int anonymous;
  final int users;

  ConfigWatchingInterval({
    required this.anonymous,
    required this.users,
  });

  factory ConfigWatchingInterval.fromJson(Map<String, dynamic> json) =>
      _$ConfigWatchingIntervalFromJson(json);
  Map<String, dynamic> toJson() => _$ConfigWatchingIntervalToJson(this);
}

// @JsonSerializable()
// class ConfigStoryboards {
//   final bool enabled;

//   ConfigStoryboards({
//     required this.enabled,
//   });

//   factory ConfigStoryboards.fromJson(Map<String, dynamic> json) =>
//       _$ConfigStoryboardsFromJson(json);
//   Map<String, dynamic> toJson() => _$ConfigStoryboardsToJson(this);
// }
