import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/shared/config/config_datasource.dart';
import 'package:peertube_mobile/shared/config/config_models.dart';
import 'package:peertube_mobile/shared/config/config_service.dart';
import 'package:peertube_mobile/shared/network/network_providers.dart';

final configDatasourceProvider = Provider<ConfigDatasource>(
  (ref) => ConfigDatasource(httpClient: ref.watch(httpClientProvider)),
  name: 'configDatasourceProvider',
);

final configServerProvider =
    FutureProvider.autoDispose.family<ConfigServer, String>(
  (ref, host) async => ref.read(configDatasourceProvider).config(
        Uri.parse('https://$host'),
      ),
);

final configServiceProvider = Provider<ConfigService>(
  (ref) => ConfigService(
    config: ref.watch(configDatasourceProvider),
  ),
  name: 'configServiceProvider',
);
