import 'dart:async';

import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/shared/config/config_providers.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_models.dart';

class CurrentPeertubePlatformNotifier extends Notifier<CurrentPlatform?> {
  @override
  CurrentPlatform? build() {
    return null;
  }

  Future<CurrentPlatform?> loadCurrentPlatform(
    Uri domain,
  ) async {
    if (state == null || state!.domain.toString() != domain.toString()) {
      await ref
          .read(configServiceProvider)
          .getPlatformInformation(domain)
          .then((value) {
        state = value;
      });
    }
    return state;
  }
}
