import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/shared/current_platform/current_platform_models.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_notifier.dart';
import 'package:peertube_mobile/shared/current_platform/current_platform_service.dart';

final currentPlatformProvider =
    NotifierProvider<CurrentPeertubePlatformNotifier, CurrentPlatform?>(
  CurrentPeertubePlatformNotifier.new,
  name: 'currentPlatformProvider',
);

final currentPlatformNonNullableProvider = Provider(
  (ref) {
    final nullableValue = ref.watch(currentPlatformProvider);

    if (nullableValue == null) {
      throw StateError(
        'The value of the currentPlatformNonNullableProvider must not be null',
      );
    }
    return nullableValue;
  },
  name: 'currentPlatformNonNullableProvider',
);

final currentPlatformServiceProvider = Provider<CurrentPlatformService>(
  (ref) => CurrentPlatformService(),
  name: 'currentPlatformServiceProvider',
);
