import 'package:flutter/material.dart';

import 'package:json_annotation/json_annotation.dart';

part 'account_params_model.g.dart';

@immutable
@JsonSerializable(includeIfNull: false)
class AccountParams {
  final int? count;
  final String? sort;
  final int? start;
  final bool? withStats;

  const AccountParams({
    this.count,
    this.sort,
    this.start,
    this.withStats,
  });

  AccountParams copyWith({int? start, int? count}) {
    return AccountParams(
      count: count ?? this.count,
      sort: sort,
      start: start ?? this.start,
      withStats: withStats,
    );
  }

  factory AccountParams.fromJson(Map<String, dynamic> json) =>
      _$AccountParamsFromJson(json);
  Map<String, dynamic> toJson() => _$AccountParamsToJson(this);
}
