import 'package:flutter/material.dart';

import 'package:json_annotation/json_annotation.dart';

part 'comment_params_model.g.dart';

@immutable
@JsonSerializable(includeIfNull: false)
class CommentParams {
  final int? count;
  final CommentSortCriteria? sort;
  final int? start;

  const CommentParams({
    this.count,
    this.sort,
    this.start,
  });

  CommentParams copyWith({int? start, int? count}) {
    return CommentParams(
      count: count ?? this.count,
      sort: sort,
      start: start ?? this.start,
    );
  }

  factory CommentParams.fromJson(Map<String, dynamic> json) =>
      _$CommentParamsFromJson(json);
  Map<String, dynamic> toJson() => _$CommentParamsToJson(this);
}

@JsonEnum(alwaysCreate: true)
enum CommentSortCriteria {
  @JsonValue('createdAt')
  createdAtAsc,

  @JsonValue('-createdAt')
  createdAtDesc,

  @JsonValue('totalReplies')
  totalRepliesAsc,

  @JsonValue('-totalReplies')
  totalRepliesDesc,
}
