import 'package:flutter/material.dart';

import 'package:json_annotation/json_annotation.dart';

part 'history_params_model.g.dart';

@immutable
@JsonSerializable(includeIfNull: false)
class HistoryParams {
  final int? count;
  final String? search;
  final int? start;

  const HistoryParams({
    this.count,
    this.search,
    this.start,
  });

  HistoryParams copyWith({int? start, int? count}) {
    return HistoryParams(
      count: count ?? this.count,
      search: search,
      start: start ?? this.start,
    );
  }

  factory HistoryParams.fromJson(Map<String, dynamic> json) =>
      _$HistoryParamsFromJson(json);
  Map<String, dynamic> toJson() => _$HistoryParamsToJson(this);
}
