import 'package:flutter/material.dart';

import 'package:json_annotation/json_annotation.dart';

import 'package:peertube_mobile/features/video/playlist/playlist_type_enum.dart';

part 'playlist_params_model.g.dart';

@immutable
@JsonSerializable(includeIfNull: false)
class PlaylistParams {
  final int? count;
  final String? sort;
  final int? start;
  final String? search;
  final PlaylistType? playlistType;

  const PlaylistParams({
    this.count,
    this.sort,
    this.start,
    this.search,
    this.playlistType,
  });

  PlaylistParams copyWith({int? start, int? count}) {
    return PlaylistParams(
      count: count ?? this.count,
      sort: sort,
      start: start ?? this.start,
      search: search,
      playlistType: playlistType,
    );
  }

  factory PlaylistParams.fromJson(Map<String, dynamic> json) =>
      _$PlaylistParamsFromJson(json);
  Map<String, dynamic> toJson() => _$PlaylistParamsToJson(this);
}
