import 'package:logging/logging.dart';

final CustomLogger log = CustomLogger('GlobalLogger');

class CustomLogger {
  final Logger _logger;

  CustomLogger(String name) : _logger = Logger(name);
  void fatal(message, [Object? error, StackTrace? stackTrace]) =>
      _logger.shout(message, error, stackTrace);
  void error(message, [Object? error, StackTrace? stackTrace]) =>
      _logger.severe(message, error, stackTrace);
  void warning(message, [Object? error, StackTrace? stackTrace]) =>
      _logger.warning(message, error, stackTrace);
  void info(message, [Object? error, StackTrace? stackTrace]) =>
      _logger.info(message, error, stackTrace);
  void debug(message, [Object? error, StackTrace? stackTrace]) =>
      _logger.config(message, error, stackTrace);

  static Level fromInt(int value) {
    for (Level level in Level.LEVELS) {
      if (level.value == value) {
        return level;
      }
    }
    throw ArgumentError('Invalid level value: $value');
  }
}
