import 'package:flutter/material.dart';

const beige300 = Color(0xfff4f4f5);
const beige350 = Color(0xffEEE9E9);
const beige400 = Color(0xffe9dfdf);
const beige450 = Color(0xffD4C7C7);
const beige500 = Color(0xffc1b0b0);
const beige600 = Color(0xff8d7777);
const orange400 = Color(0xffFD9C50);
const orange500 = Color(0xfff2690d);
const orange600 = Color(0xffFB5200);
const brown300 = Color(0xff553D3D);
const brown400 = Color(0xff3C2E2E);
const brown450 = Color(0xff2e2323);
const brown500 = Color(0xff221a1a);
const brown550 = Color(0xff111111);
const brown600 = Color(0xff0a0a0a);

const ColorScheme lightColorScheme = ColorScheme(
  brightness: Brightness.light,
  primary: orange500,
  onPrimary: brown500,
  secondary: beige300,
  onSecondary: brown300,
  secondaryContainer: beige450,
  surfaceContainerLowest: beige300,
  surfaceContainerLow: beige300,
  surfaceContainer: beige450,
  surfaceContainerHigh: beige400,
  surfaceContainerHighest: beige450,
  surface: beige350,
  onSurface: brown500,
  onSurfaceVariant: brown450,
  onTertiary: brown550,
  onError: brown500,
  error: Colors.red,
  outline: orange500,
);
const ColorScheme darkColorScheme = ColorScheme(
  brightness: Brightness.dark,
  primary: orange500,
  onPrimary: beige300,
  secondary: brown500,
  onSecondary: beige500,
  secondaryContainer: brown300,
  surfaceContainerLowest: brown600,
  surfaceContainerLow: brown550,
  surfaceContainer: brown450,
  surfaceContainerHigh: brown450,
  surfaceContainerHighest: brown400,
  surface: brown600,
  onSurface: beige300,
  onSurfaceVariant: beige400,
  onTertiary: beige600,
  onError: beige300,
  error: Colors.red,
  outline: orange500,
  primaryFixed: orange400,
);
