import 'package:flutter/material.dart';

import 'package:flutter_riverpod/flutter_riverpod.dart';

import 'package:peertube_mobile/shared/preferences/user_preferences.dart';

final themeProvider = StateProvider<ThemeMode>((ref) {
  SharedUtility sharedUtility = ref.watch(sharedUtilityProvider);
  int themeModeIndex = sharedUtility.currentThemeIndex;

  ref.listenSelf((ThemeMode? prev, ThemeMode curr) {
    sharedUtility.setTheme(curr);
  });

  return ThemeMode.values[themeModeIndex];
});
