import 'package:dio/dio.dart';

import 'package:peertube_mobile/shared/current_platform/current_platform_models.dart';
import 'package:peertube_mobile/shared/user/user_model.dart';

class UserDatasource {
  final CurrentPlatform currentPlatform;
  final Dio peertubeClient;

  UserDatasource({
    required this.currentPlatform,
    required this.peertubeClient,
  });

  Future<User> getMyUser() async {
    try {
      final response = await peertubeClient.get(
        currentPlatform.getApiBaseUrl('/users/me'),
      );

      return User.fromJson(response.data);
    } catch (e) {
      throw Exception('An error has occurred : $e');
    }
  }

  Future<void> updateMyUser() async {
    //TODO
  }
}
