import 'package:json_annotation/json_annotation.dart';

import 'package:peertube_mobile/features/account/account_model.dart';
import 'package:peertube_mobile/features/video/channel/channel_model.dart';
import 'package:peertube_mobile/shared/user/models/role_model.dart';
import 'package:peertube_mobile/shared/user/nsfw_policy_enum.dart';

part 'user_model.g.dart';

@JsonSerializable()
class User {
  final AccountDetails account;
  final bool autoPlayNextVideo;
  final bool autoPlayNextVideoPlaylist;
  final bool autoPlayVideo;
  final bool blocked;
  final String blockedReason;
  final String createdAt;
  final String email;
  final bool emailVerified;
  final int id;
  final String pluginAuth;
  final String lastLoginDate;
  final bool noInstanceConfigWarningModal;
  final bool noAccountSetupWarningModal;
  final bool noWelcomeModal;
  final NsfwPolicy nsfwPolicy;
  final Role role;
  final String theme;
  final String username;
  final List<VideoChannelDetails> videoChannels;
  final int videoQuota;
  final int videoQuotaDaily;
  final bool p2pEnabled;

  User({
    required this.account,
    required this.autoPlayNextVideo,
    required this.autoPlayNextVideoPlaylist,
    required this.autoPlayVideo,
    required this.blocked,
    required this.blockedReason,
    required this.createdAt,
    required this.email,
    required this.emailVerified,
    required this.id,
    required this.pluginAuth,
    required this.lastLoginDate,
    required this.noInstanceConfigWarningModal,
    required this.noAccountSetupWarningModal,
    required this.noWelcomeModal,
    required this.nsfwPolicy,
    required this.role,
    required this.theme,
    required this.username,
    required this.videoChannels,
    required this.videoQuota,
    required this.videoQuotaDaily,
    required this.p2pEnabled,
  });

  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);
  Map<String, dynamic> toJson() => _$UserToJson(this);
}
