import 'package:flutter/material.dart';

import 'package:intl/intl.dart';

import 'package:peertube_mobile/shared/utils/translate.dart';

String timeago(DateTime arg, BuildContext context) {
  final seconds =
      ((DateTime.now().millisecondsSinceEpoch - arg.millisecondsSinceEpoch) /
              1000)
          .floor();

  var interval = (seconds / 31536000).floor();
  if (interval >= 1) {
    return Intl.plural(
      interval,
      one: t(context)!.oneYearAgo,
      other: t(context)!.yearsAgo(interval),
    );
  }

  interval = (seconds / 2419200).floor();
  if (interval >= 12) return t(context)!.oneYearAgo;

  if (interval >= 1) {
    return Intl.plural(
      interval,
      one: t(context)!.oneMonthAgo,
      other: t(context)!.monthsAgo(interval),
    );
  }

  interval = (seconds / 604800).floor();
  if (interval >= 4) return t(context)!.oneMonthAgo;

  if (interval >= 1) {
    return Intl.plural(
      interval,
      one: t(context)!.oneWeekAgo,
      other: t(context)!.weeksAgo(interval),
    );
  }

  interval = (seconds / 86400).floor();
  if (interval >= 1) {
    return Intl.plural(
      interval,
      one: t(context)!.oneDayAgo,
      other: t(context)!.daysAgo(interval),
    );
  }

  interval = (seconds / 3600).floor();
  if (interval >= 1) {
    return Intl.plural(
      interval,
      one: t(context)!.oneHourAgo,
      other: t(context)!.hoursAgo(interval),
    );
  }

  interval = (seconds / 60).floor();
  if (interval >= 1) return t(context)!.minAgo(interval);

  return t(context)!.justNow;
}

String formatDuration(Duration duration) {
  String twoDigits(int n) => n.toString().padLeft(2, '0');

  if (duration.inHours > 0) {
    return '${duration.inHours}:${twoDigits(duration.inMinutes.remainder(60))}:${twoDigits(duration.inSeconds.remainder(60))}';
  } else {
    return '${duration.inMinutes}:${twoDigits(duration.inSeconds.remainder(60))}';
  }
}
