import 'package:peertube_mobile/shared/actor/actor_image_model.dart';

String? getImagePathForSize(List<ActorImage> images, double targetWidth) {
  final validAvatars = images.where((avatar) => avatar.width != null).toList();
  if (validAvatars.isEmpty) return null;
  validAvatars.sort((a, b) => (a.width ?? 0).compareTo(b.width ?? 0));

  ActorImage? selectedAvatar;
  for (var avatar in validAvatars) {
    if ((avatar.width ?? 0) >= targetWidth) {
      selectedAvatar = avatar;
      break;
    }
  }

  selectedAvatar ??= validAvatars.last;

  return selectedAvatar.path;
}
