import 'package:flutter/material.dart';

class CustomCheckboxListTile extends StatefulWidget {
  final bool value;
  final String title;
  final ValueChanged<bool?> onChanged;
  final Icon? icon;

  const CustomCheckboxListTile({
    super.key,
    required this.value,
    required this.title,
    required this.onChanged,
    this.icon,
  });

  @override
  State<CustomCheckboxListTile> createState() => _CustomCheckboxListTileState();
}

class _CustomCheckboxListTileState extends State<CustomCheckboxListTile> {
  late bool _isChecked;

  @override
  void initState() {
    super.initState();
    _isChecked = widget.value;
  }

  void _handleTap() {
    setState(() {
      _isChecked = !_isChecked;
    });
    widget.onChanged(_isChecked);
  }

  @override
  Widget build(BuildContext context) {
    return CheckboxListTile(
      value: _isChecked,
      onChanged: (bool? value) {
        _handleTap();
      },
      title: Text(widget.title),
      secondary: widget.icon,
    );
  }
}
